
rem -- number.mcr

rem -- 1.1	Replaced ToMacro: with ToBack: for performance
rem --			Changed double right arrow to Word tab character
rem --			Added message when no selection
rem --			Changed dChoice menu to dText
rem --			Changed custom tokens for character and number
rem --			Added roman numeral support
rem --			Changed letters to go beyond z
rem --
rem -- 1.0	First cut
rem -- 0.9	Accidentally uploaded to Compuserve.
rem --			Only the custom numbering style worked


PROC macro:

	global x$(255)
	global prefix$(25)
	global postfix$(25)
	local curnum%
	local style%

	UseApp: ("Active")

	bringsvr:	rem Setup bring server

	x$=GetText$:

	if Len(x$)=0
		giPrint: ("No selection")
	else	
		style%=getstyle:
		if style%>0		
			rem setup start of number
			curnum%=1
	
			marktext:
		
			x$=""
			while loc(x$, "") = 0
				if style%=1
						SendText: (prefix$+Gen$(curnum%, 3)+postfix$) rem insert number
				elseif style%=2
						SendText: (prefix$+Alpha$:(curnum%)+postfix$) rem insert number
				else
						SendText: (prefix$+Roman$:(curnum%)+postfix$)
				endif

				curnum%=curnum%+1
				SendKey: (down%, ctrl%, 1)
				Left:
				SendKey: (right%, ctrl%, 1)
				SendKey: (263, 8, 1)
				SendKey: (262, 10, 1)
				x$=GetText$:
				Left:
			endwh

			rem DELETE END MARKER
			SendKey: (614, 8, 1)	rem invoke find	
			SendKey: (207, 4, 1)	
			SendKey: (207, 4, 1)
			Down:
			Tab:
			Up:
			Enter:
			Enter:
			Delete:
		endif
	endif


ENDP

PROC getstyle:

	rem setup prefix and postfix strings
	rem returns 1 numeric, 2 alphabetic, 3 numerals

	local style%, x%
	local choice$(9, 25)
	
	choice$(1)="1. Paragraph" 
	choice$(2)="1.	Paragraph"
	choice$(3)="1  Paragraph"
	choice$(4)="1	Paragraph"
	choice$(5)="a. Paragraph" 
	choice$(6)="a.	Paragraph"
	choice$(7)="a  Paragraph"
	choice$(8)="a	Paragraph"
	choice$(9)="Custom"

	
	rem prompt for style
	dInit: ("")
	x%=1
	while x%<10
		dText: ("", choice$(x%), $400)
		x%=x%+1
	endwh
	
	style% = DIALOG:
		
	if style%>8
		style%=custom:
	elseif style%>0		

		rem setup postfix string
		if style%=1 or style%=2 or style%=5 or style%=6
			postfix$=postfix$+"."
		endif			

		if style%=1 or style%=3 or style%=5 or style%=7
			postfix$=postfix$+" "
		endif			

		if style%=2 or style%=4 or style%=6 or style%=8
			postfix$=postfix$+"	"
		endif
		
		if style%<5
			style%=1
		else
			style%=2
		endif
	endif
	
	return style%
ENDP

PROC custom:

	local style%, x%
	local custom$(25)

	rem Prompt for custom style
	dInit: ("Custom number style")
	dText: ("", "Use # for number", 0)
	dText: ("", "Use @ for letter", 0)
	dText: ("", "Use ~ for numerals", 0)
	dText: ("", "Use + for tab", $200)
	dText: ("eg 1.2@+", "1.2a   Paragraph", 0)
	dText: ("eg 1.2.#+","1.2.1   Paragraph", 0)
	dText: ("eg ~.+","i.   Paragraph", $200)
	dEdit: (addr(custom$), "Style", 20)
	style%=DIALOG:
			
	if style%>0 rem check return was pressed
		if (loc(custom$, "#")>0)
			style%=1	rem numeric
		elseif (loc(custom$, "@")>0)
			style%=2	rem character
		elseif loc(custom$, "~")>0
			style%=3	rem numerals
		else
			giPrint: ("Invalid style")
			style%=0
		endif
				
		if style%>0	rem check valid style

			rem parse tabs
			x%=loc(custom$, "+")
			while x%>0
				custom$=left$(custom$, x%-1) + "	" + right$(custom$, len(custom$)-x%)
				x%=loc(custom$, "+")
			endwh
				
			rem Get prefix and postfix
			x%=loc(custom$, "#")
			if x%=0
				x%=loc(custom$, "@")
			endif

			if x%=0
				x%=loc(custom$, "~")
			endif

			prefix$=Left$(custom$, x%-1)
			postfix$=Right$(custom$, len(custom$)-x%)
		endif
	endif
	
	return (style%)
ENDP

PROC bringsvr:
	rem SETUP BRING SERVER
	SendKey: (right%, shift%, 1)
	if CurrPid%: <> SrvPid%:
		ToMacro:
		ToFront:
	endif
	SendKey: (left%, shift%, 1)
ENDP


PROC marktext:
 
			Delete:

			SendKey: (207, 4, 1)	rem mark start
			SendKey: (207, 4, 1)	rem mark end		
			SendKey: (207, 4, 1)	rem mark end
			SendKey: (left%, 0, 2)
			SendKey: (617, 8, 1)	rem insert
			Left:
		
			rem MOVE THE START MARKER TO START OF FIRST PARA
			SendKey: (up%, ctrl%, 1)
			SendKey: (614, 8, 1)	rem invoke find
			SendKey: (207, 4, 1)
			Down:
			Tab:
			Up:
			Enter:
			Enter:
		
			rem Goto the beginning of first paragraph
			Right:
			SendKey: (up%, ctrl%, 1)
			SendKey: (right%, shift%, 1)
			x$=GetText$:
			Left:
			if x$<>""
				SendKey: (207, 4, 1)	rem insert new start marker
				SendKey: (614, 8, 1)	rem delete old marker
				Enter:
				Delete:
			endif
			
		
			rem MOVE END MARKER TO END OF LAST PARA
			SendKey: (614, 8, 1)	rem invoke find
			SendKey: (207, 4, 1)
			SendKey: (207, 4, 1)
			Down:
			Tab:
			Up:
			Enter:
			Enter:
		
			rem Check positioning of end marker
			Right:
			SendKey: (up%, ctrl%, 1)
			SendKey: (right%, shift%, 2)
			x$=GetText$:
			if loc(x$, "")<>1
				SendKey: (614, 8, 1)	rem delete old marker
				Enter:
				Delete:
				SendKey: (up%, ctrl%, 1)
				SendKey: (down%, ctrl%, 1)
				Left:
				SendKey: (right%, ctrl%, 1)
				SendText: ("")
			endif
		
			rem FIND BEGINNING OF BLOCK
			Left:	rem skip end marker
			Left:
			SendKey: (614, 8, 1)	rem invoke find
			SendKey: (207, 4, 1)
			Down:
			Tab:
			Down:
			Enter:
			Enter:
			Delete:
ENDP

PROC Roman$:(x%)

	rem convert x% to roman numerals
	rem go up to 39 only
	
	local rmn$(11, 4)
	
	rmn$(1)=""
	rmn$(2)="i"
	rmn$(3)="ii"
	rmn$(4)="iii"
	rmn$(5)="iv"
	rmn$(6)="v"
	rmn$(7)="vi"
	rmn$(8)="vii"
	rmn$(9)="viii"
	rmn$(10)="ix"
	rmn$(11)="x"

	if x%>10	
		return Rept$("x", int(x%/10))+rmn$(1+x%-(int(x%/10))*10)
	elseif x%>0
		return rmn$(x%+1)
	else
		return ""
	endif
ENDP

PROC Alpha$:(x%)

	if x%<27
		return (Chr$(%a+x%-1))
	else
		return (Chr$(%a-1+x%/26))+Chr$(%a-1+x%-(int(x%/26)*26))
	endif

ENDP 
