rem -- For this macro to work you need at
rem -- least one line of non outline (eg BT)
rem -- text between headings.

rem -- This macro assumes that headings are
rem -- not wrapped across lines.

rem -- You must enure that there are no
rem -- empty headers.

rem -- You must also ensure that the style ZZ
rem -- is not in use.

rem -- 1.1	Replaced ToBack: with ToMacro: for performance
rem -- 			Changed dialog from dButtons to dText
rem --			Remember start and end settings across invocations
rem --
rem -- 1.0	First cut

PROC macro:

	global level%(9)
	global strtlvl%
	global endlvl%
	local x%

	UseApp: ("Active")

	if var%(3)=0
		strtlvl%=1
	else
		strtlvl%=var%(3)
	endif
	
	if var%(4)=0
		endlvl%=3
	else
		endlvl%=var%(4)
	endif
	
	
	if dodlg%: > 0
		if strtlvl%>endlvl% or strtlvl%=0
			GiPrint: ("Invalid start level")
		else

			minit:	

			x%=1
			while x%<=endlvl%
				mklevel:(x%)
				x%=x%+1
			endwh
	
			number:(strtlvl%, endlvl%)
			mdeinit:

			var%(3)=strtlvl%
			var%(4)=endlvl%
			
			SendKey: (pgup%, ctrl%, 1)
			modeot:
		endif
	endif

ENDP

PROC modeot:
	rem -- switch to outline mode
	
	rem switch to normal mode if in outline
	SendKey: (27, 0, 1)
	SendKey: (623, 10, 1)
ENDP

PROC modenm:
	rem set -- normal mode
	SendKey: (27, 0, 1)
ENDP

PROC minit:

	rem -- macro initialisation

	rem setup bring server
	BringSvr:
	
	rem goto end of document
	modenm:
	SendKey: (261, 12, 1)
	
	rem set up internal marker
	SendText: ("x")
	Enter:
	SendText: ("E")
	
	rem set up our own outline level 1
	SendKey: (616, 10, 1)
	SendKey: (612, 8, 1)
	Up:
	SendText: ("1")
	Enter:
	SendText: ("ZZZZ Temp")
	Down:
	SendText: ("ZZ")
	Enter:
ENDP

PROC mdeinit:

	rem -- deinitialise macro
	
	rem delete internal marker
	modenm:
	SendKey: (261, 12, 1)
	SendKey: (262, 10, 1)
	Delete:
	Delete:
	Delete:
	
	rem delete our outline style
	SendKey: (616, 10, 1)
	SendKey: (632, 8, 1)
	Left:
	Delete:
	SendKey: (27, 0, 1)
	
ENDP

PROC otlevel:(x%)

	rem -- set outline level
	SendKey: (616, 8, 1)
	SendKey: (48+x%, 0, 1)
	Enter:
ENDP 

PROC mklevel:(x%)

	local x$(255)
	rem -- mark level
	
	rem go home
	SendKey: (260, 12, 1)
	
	otlevel:(x%)
	modeot:
	SendKey: (262, 8, 1)
	SendKey: (right%, shift%, 3)
	x$=GetText$:
	SendKey: (left%, shift%, 3)
	
	while Left$(x$, 3) <> "E"
		if Left$(x$, 1) <> ""
			SendText: (""+Gen$(x%, 1)+"")
			modeot:
		endif
		Down:
		SendKey: (262, 8, 1)
		SendKey: (right%, shift%, 3)
		x$=GetText$:
		SendKey: (left%, shift%, 3)
	endwh
	
ENDP

PROC bringsvr:
	rem SETUP BRING SERVER
	SendKey: (right%, shift%, 1)
	if CurrPid%: <> SrvPid%:
		ToMacro:
		ToFront:
	endif
	SendKey: (left%, shift%, 1)
ENDP

PROC number:(start%, end%)

	local x$(255)
	local number$(30)
	local x%
	local lastlvl%, curlvl%
	
	lastlvl%=1

	rem -- number outline from level start to level end
	rem -- assumes in outline mode on entry
	
	rem goto start of doc
	SendKey: (260, 12, 1)
	SendKey: (262, 8, 1)
	
	rem select first three chars
	SendKey: (258, 2, 3)
	
	x$=GetText$:
	while x$<>"E"
		curlvl%=Val(Mid$(x$, 2, 1))

		if curlvl%>lastlvl%
			
			if lastlvl%<strtlvl%
				lastlvl%=strtlvl%+1
				level%(strtlvl%)=level%(strtlvl%)+1
			else
				lastlvl%=lastlvl%+1
			endif
			
			rem - reset all levels from lastlevel up to current level
			while lastlvl%<=curlvl%
				level%(lastlvl%)=1
				lastlvl%=lastlvl%+1
			endwh
			lastlvl%=curlvl%
		elseif curlvl%=lastlvl%
			level%(lastlvl%)=level%(lastlvl%)+1
		elseif curlvl%<lastlvl%
			level%(curlvl%)=level%(curlvl%)+1
			lastlvl%=curlvl%
		endif
		
		if curlvl%<start% or curlvl%>end%
			Delete:	rem level is out of bounds
		else
		
			rem build up number string
			number$=""

			x%=start%
			while x%<curlvl%
				number$=number$+gen$(level%(x%), 2)+"."
				x%=x%+1
			endwh

			number$=number$+gen$(level%(curlvl%), 2)+" "
			SendText: (number$)
		endif

		modeot:
		Down:
		SendKey: (262, 8, 1)
		SendKey: (258, 2, 3)
		x$=GetText$:

	endwh

ENDP

PROC dodlg%:

	local x%
	
	do
		dInit: ("Number Headings")
		dText: ("Generate numbers", "", $600)
		dText: ("Start at level", Gen$(strtlvl%, 1), $400)
		dText: ("End at level", Gen$(endlvl%, 1), $400)

		x%=Dialog:
		
		if x%=3
			strtlvl%=getlvl%:("Start at level")
		elseif x%=4
			endlvl%=getlvl%:("End at level")
		endif
		
	until x%=0 or x%=2
	return x%	
	
ENDP

PROC getlvl%:(prompt$)

	local x%
	
	x%=1
	
	dInit:("")
	while x%<9
		dText:(prompt$, Gen$(x%, 1), $400)
		x%=x%+1
	endwh
	
	x%=Dialog:
	
	if x%=0
		x%=1
	endif
	
	return x%
ENDP
